// threadprivate - primer iz prosojnic

#include "omp.h"
#include <stdio.h>

int log[6][2][2] = {{0}};
int varFP = 0;
int varTP = 0;
#pragma omp threadprivate(varTP)

void main(void)
{
	int i,j, tn;

	int Tn = omp_get_thread_num();
	log[0][Tn][0] = varFP; log[0][Tn][1] = varTP;
	#pragma omp parallel copyin(varTP) firstprivate(varFP)
	{
		int tn = omp_get_thread_num();
		varFP = varFP + (tn+1); varTP = varTP + (tn+1); 
		log[1][tn][0] = varFP; log[1][tn][1] = varTP;
	}
	log[2][Tn][0] = varFP; log[2][Tn][1] = varTP;
	varFP = varFP + 10*(Tn+1); varTP = varTP + 10*(Tn+1); 
	log[3][Tn][0] = varFP; log[3][Tn][1] = varTP;
	#pragma omp parallel firstprivate(varFP)
	{
		int tn = omp_get_thread_num();
		varFP = varFP + 100*(tn+1); varTP = varTP + 100*(tn+1); 
		log[4][tn][0] = varFP; log[4][tn][1] = varTP;
	}
	log[5][Tn][0] = varFP; log[5][Tn][1] = varTP;

	for(i=0; i<6; i++)
	{
		printf("K%d:: ",i);
		for(j=0; j<2; j++)
			printf("N%d: FP=%3d, TP=%3d | ", j, log[i][j][0], log[i][j][1]);
		printf("\n");
	}
}
