// ra"cunanje pi z integracijo funkcije 4/(1+a*a) na intervalu [0, 1]

#include <stdio.h>
#include <math.h>
#include <ti.h>

#define INTERVALS 100000000

double f(double a)
{
	return (4/(1+pow(a,2)));
}

int main(int argc, char* argv[])
{
	time_t t1, t2;
	int i;
	double sum = 0.0;	
	double h = 1.0 / INTERVALS;					
	
	time(&t1);

	for( i = 0; i < INTERVALS; i++ )
	{
		sum += f(h*i);
	}
		
	time(&t2);

	printf("Rezultat: %1.16lf, cas: %d s\n", h*sum, t2-t1);
}
